# -*- coding: utf-8 -*-

from joblib import Parallel, delayed


def joblib_parl(func, args_list, n_jobs, backend='loky',
                **kw_jb):
    jb = Parallel(n_jobs=n_jobs, backend=backend, **kw_jb)
    res = jb(delayed(func)(*args) for args in args_list)
    return res


if __name__ == '__main__':
    import numpy as np
    import time
    from dramkit import TimeRecoder
    tr = TimeRecoder(monotonic=True)
    
    def test_add(a, b):
        time.sleep(1)
        return a + b
    
    n = 20
    args_list = zip(np.random.rand(n), np.random.rand(n))
    
    res = joblib_parl(test_add, args_list,
                      n_jobs=5,
                      backend='threading',
                      # backend='loky',
                      # backend='multiprocessing'
                      )
    
    
    tr.used()